using System;
using System.Collections.Generic;
using System.Text;
using Terraria;
using TAPI;

namespace Terra.Buffs
{
    public class MonadoJump : TAPI.ModBuff
    {     
        public override void Effects(Player p, int index)
        {
            p.jumpSpeedBoost += 3.25f;
	    p.jumpBoost = true;
	    p.endurance += 0.2f;
	    p.knockbackResist = 0f;
	    p.noFallDmg = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoSpeed"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoShield"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoBuster"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoSmash"]] = true;
        }
    }
}