using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Items
{
    public class HunterChestplate : ModItem
    {
        public override void Effects(Player p)
        {
            p.rangedDamage += 0.11f;
        }

	public override void ArmorSetBonus(Player p)
	{
            p.setBonus = "When close to prey, increased stats and detection";

            float closestDistance = 250f;
	    for(int k = 0; k < 200; k++)
	    {
		NPC npc = Main.npc[k];
		if(npc.active && !npc.friendly)
		{
        	    if(Vector2.Distance(npc.Center, p.Center) < closestDistance)
        	    {
            		p.detectCreature = true;
			p.moveSpeed = 5f;
			p.moveSpeedMax = 5f;
			p.rangedDamage += 0.004f;
        	    }
		}
	    }
	}
    }
}