using Terraria;
using System;
using System.Diagnostics;
using Microsoft.Xna.Framework;

using TAPI;

namespace Terra.Items
{
public class BlazingPickaxe : ModItem
    {
	public override void UseItemEffects(Player player, Rectangle rectangle)
	{
	    int dustID = Dust.NewDust(new Vector2((float)rectangle.X, (float)rectangle.Y), rectangle.Width, rectangle.Height, 6, (player.velocity.X * 0.2f) + (player.direction * 3), player.velocity.Y * 0.2f, 100, Color.Orange, 0.7f + (Main.rand.Next(6) * 0.1f));
	    Main.dust[dustID].noGravity = true;
	}
        public override void DamageNPC(Player owner, NPC npc, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
        {
            npc.AddBuff (24, 180, true);
        }
    }
}