using Terraria;
using System;
using System.Diagnostics;
using Microsoft.Xna.Framework;

using TAPI;

namespace Terra.Items
{
public class PetalRepeater : ModItem
    {
       public override bool PreShoot(Player player,Vector2 ShootPos,Vector2 ShootVelocity,int projType,int Damage,float knockback) //This code is performed before the player shoots the weapon. Copy these parameters exactly if you want it to work.
        {
            int ShotAmt = 2; //Amount of projectiles fired from the weapon. If you want to make a slightly inaccurate machine gun type of weapon, set this to 1
            int spread = 30; //The angle of random spread.
            float spreadMult = 0.05f; //Multiplier for bullet spread, set it higher and it will make for some outrageous spread.
            for(int i = 0; i < ShotAmt; i++)
            {
                float vX = ShootVelocity.X+(float)Main.rand.Next(-spread,spread+1) * spreadMult;
                float vY = ShootVelocity.Y+(float)Main.rand.Next(-spread,spread+1) * spreadMult;

                Projectile.NewProjectile(ShootPos.X,ShootPos.Y,vX,vY,projType,Damage,knockback,Main.myPlayer);
            }
            return false;
        }
    }
}