using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Terra //Your mod's internal name
{
    [GlobalMod]
    public class MNPC : ModNPC
    {
        public override void PostSetupShop(Chest shop, ref int lastIndex)
        {
            if (npc.type == 108) //Wizard
            {
                shop.item[lastIndex++].SetDefaults("Terra:Scroll"); //item
            }

            if (npc.type == 107) //Goblin Tinkerer
            {
                shop.item[lastIndex++].SetDefaults("Terra:Tinkershot"); //item
            }

            if (npc.type == 17) //Merchant
            {
		if (NPC.downedBoss1 == true)
		{
                    shop.item[lastIndex++].SetDefaults("Vanilla:Bottle"); //item
		}
            }
            if (npc.type == 368) //Traveling Merchant
            {
		if (Main.rand.Next(1,20) == 1)
		{
                    shop.item[lastIndex++].SetDefaults("Terra:Bloodstonemagnet"); //item
		}
            }
            if (npc.type == 353) //Stylist
            {
		if (Main.player[Main.myPlayer].HasItem(ItemDef.byName["Terra:SoulofValue"].type));
		{
                    shop.item[lastIndex++].SetDefaults("Terra:ValueHairDye"); //item
		}
            }
        }
        public override void PostNPCLoot()
        {
    	    if (npc.type == 262)
    	{    
            MWorld.PetalOre();

	    string text = "Petal Ore has been released!";
	    if (Main.netMode == 0)
	    {
		Main.NewText(text, Color.Pink, false);
		return;
	    }
	    if (Main.netMode == 2)
	    {
		NetMessage.SendData(25, -1, -1, text, 255, 175f, 75f, 255f, 0f);
	    }
   	}
    	    if (npc.type == 245)
    	{    
            MWorld.GolemOre();

	    string text = "Golem's Pieces have been spread around the world!";
	    if (Main.netMode == 0)
	    {
		Main.NewText(text, Color.Brown, false);
		return;
	    }
	    if (Main.netMode == 2)
	    {
		NetMessage.SendData(25, -1, -1, text, 255, 175f, 75f, 255f, 0f);
	    }
   	}
    	    if (npc.type == 127 || npc.type == 145 || npc.type == 125 || npc.type == 126)
    	{    
            MWorld.MechaOre();

	    string text = "True Mechanical have been spread around the world!";
	    if (Main.netMode == 0)
	    {
		Main.NewText(text, Color.White, false);
		return;
	    }
	    if (Main.netMode == 2)
	    {
		NetMessage.SendData(25, -1, -1, text, 255, 175f, 75f, 255f, 0f);
	    }
   	}
            if(npc.type == 245) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 4) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Lihzahrdlantern"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 58) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 20) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Piranhastaff"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 42) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 3) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Poisonpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 23) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 2) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Burningpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 94) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 4) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Weakpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 77) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 5) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Brokenarmorpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 104) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 2) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Bleedingpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 75) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 6) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Slowpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 93) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 6) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Confusedpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 79) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 1) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Darknesspluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 103) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 1) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Silencedpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 34) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 1) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Cursedpluspotion"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 6) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 25) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Eatereye"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 239) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 25) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Bloodcrawlereggsac"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 158) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 100) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Vampirismcloak"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 370) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 10) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Bubblewall"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 66) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 10) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Cerberus"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 61) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 25) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:Vulturefeather"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 345) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 20) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:IceQueenHelmet"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 345) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 20) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:IceQueenBreastplate"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 345) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 20) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:IceQueenGreaves"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 346) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 50) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SantankMask"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 346) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 50) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SantankPlating"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 346) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 50) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SantankTreads"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 251) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 100) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:BrokenHeroBow"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 325) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 10) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:MourningShield"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 212) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 33) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SoulofValue"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 213) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 33) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SoulofValue"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 214) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 33) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SoulofValue"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 215) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 33) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:SoulofValue"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
            if(npc.type == 253) //Replace "77" with the ID of the mob you are adding the drop to. Seperate mobs with "||"
        {
            if(Main.rand.Next(1, 300) == 1) //Drop chance. Change the "100" value to whatever you want. e.g. 50 is 1/50 chance
            {
                Item.NewItem((int)npc.position.X, (int)npc.position.Y, npc.width / 2, npc.height / 2, ItemDef.byName["Terra:EnchanterSword"].type, 1, false, 0); //Replace "InternalModName" with the internal name of your mod. Replace "ItemName" with the item you are adding as a drop
            }
        }
    }
	public override void SetupLootRules(NPC npc)
	{
		LootRule.settingUp = true;
		LootRule.AddFor("Everscream",
		new LootRule().Chance(1.0 / 1.0).Item("Terra:Pinewood").Stack(15,40)
		);
		LootRule.settingUp = true;
		LootRule.AddFor("Harpy",
		new LootRule().Chance(0.4 / 1.0).Item("Vanilla:Sunplate Block").Stack(10,15)
		);
		LootRule.settingUp = true;
		LootRule.AddFor("Pirate Captain",
		new LootRule().Chance(1.0 / 1.0).Item("Terra:SoulofValue").Stack(1,3)
		);
		LootRule.settingUp = true;
		LootRule.AddFor("Red Devil",
		new LootRule().Chance(0.5 / 1.0).Item("Terra:MagmaPowder").Stack(2,5)
		);
		LootRule.settingUp = true;
		LootRule.AddFor("Lava Bat",
		new LootRule().Chance(0.1 / 1.0).Item("Terra:MagmaPowder").Stack(1,3)
		);
		LootRule.settingUp = true;
		LootRule.AddFor("Golem",
		new LootRule().Chance(0.8 / 1.0).Item("Terra:GolemPowerCore").Stack(1,1)
		);
	}
    }
}
