using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Projectiles
{
    public class ElectrolyteVolt : ModProjectile
    {
	public override void AI()
	{
		projectile.rotation = (float)System.Math.Atan2((double)projectile.velocity.Y, (double)projectile.velocity.X) + 1.57f;
		if(projectile.timeLeft % 2 == 0 && Main.netMode != 2)
		{
			int dustID = Dust.NewDust(projectile.position, projectile.width, projectile.height, 64, projectile.velocity.X * 0.1f, projectile.velocity.Y * 0.1f, 20, Color.White, 0.6f);
		}
	}

	public override bool OnTileCollide(ref Vector2 velocityChange) //Thanks to Diverman Sam for this wonderful code for bouncing off walls! (Notes: After hitting the wall, bounces in half the velocity, just remove the divide by two if you want it to stay constant)
	{
	    if (projectile.velocity.X != velocityChange.X)
		{
		    projectile.velocity.X = -velocityChange.X; 
		}
	    if (projectile.velocity.Y != velocityChange.Y)
		{
		    projectile.velocity.Y = -velocityChange.Y;
		}
	    return false;
	}
    }
}