using System;
using System.Collections.Generic;
using System.Text;
using Terraria;
using TAPI;

namespace Terra.Buffs
{
    public class MonadoShield : TAPI.ModBuff
    {     
        public override void Effects(Player p, int index)
        {
            p.jumpSpeedBoost = 0.2f;
	    p.knockbackResist = 0f;
	    p.moveSpeed = 0.3f;
	    p.endurance = 1.35f;
	    p.buffImmune[BuffDef.byName["Terra:MonadoJump"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoSpeed"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoBuster"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoSmash"]] = true;
        }
    }
}