using System;
using System.Collections.Generic;
using System.Text;
using Terraria;
using TAPI;

namespace Terra.Buffs
{
    public class MonadoSpeed : TAPI.ModBuff
    {     
        public override void Effects(Player p, int index)
        {
            p.moveSpeed += 0.8f;
	    p.moveSpeedMax = 4f;
	    p.meleeDamage -= 0.12f;
	    p.rangedDamage -= 0.12f;
	    p.magicDamage -= 0.12f;
	    p.minionDamage -= 0.12f;
	    p.buffImmune[BuffDef.byName["Terra:MonadoJump"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoShield"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoBuster"]] = true;
	    p.buffImmune[BuffDef.byName["Terra:MonadoSmash"]] = true;
        }
    }
}