using System;
using System.Collections.Generic;
using System.Text;
using Terraria;
using TAPI;

namespace Terra.Buffs
{
    public class SorVaacMagic : TAPI.ModBuff
    {     
        public override void Effects(Player p, int index)
        {
	    p.magicDamage += 0.18f;
	    p.magicCrit += 18;
	    p.manaCost -= 0.18f;
	    p.buffImmune[BuffDef.byName["Terra:SorVaacMelee"]] = true;
        }

	public override void DamageNPC(Player p, NPC n, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
	{
	    p.AddBuff ("Terra:SorVaacMinion", 900, true);
	    p.ClearBuff ("Terra:SorVaacMagic");
	}
    }
}