using System;
using System.Collections.Generic;
using System.Text;
using Terraria;
using TAPI;

namespace Terra.Buffs
{
    public class SorVaacRanged : TAPI.ModBuff
    {     
        public override void Effects(Player p, int index)
        {
	    p.rangedDamage += 0.18f;
	    p.rangedCrit += 18;
	    p.ammoCost80 = true;
	    p.buffImmune[BuffDef.byName["Terra:SorVaacMelee"]] = true;
        }

	public override void DamageNPC(Player p, NPC n, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
	{
	    p.AddBuff ("Terra:SorVaacMagic", 900, true);
	    p.ClearBuff ("Terra:SorVaacRanged");
	}
    }
}