using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Items
{
    public class MonadoShield : ModItem
    {
	public override void Effects(Player p) //This is called a hook. This is where the effects are called. In this instance, it is called when the player has it equipped. It must have the correct parameters (the "Player p" thing) or else the builder will give you errors.
        {
            p.knockbackResist = 0;
        }
	public override void DamageNPC(Player p, NPC n, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
	{
		if (crit)
		    {
			int choice = Main.rand.Next(5);
			    if(choice == 0)
			    {
    				p.AddBuff("Terra:MonadoJump",720,true);
			    }
			    else if(choice == 1)
			    {
			    	p.AddBuff("Terra:MonadoSpeed",720,true);
			    }
			    else if(choice == 2)
			    {
			    	p.AddBuff("Terra:MonadoShield",720,true);
			    }
			    else if(choice == 3)
			    {
			    	p.AddBuff("Terra:MonadoBuster",720,true);
			    }
			    else if(choice == 4)
			    {
			    	p.AddBuff("Terra:MonadoSmash",720,true);
			    }
		    }
	}
    }
}