using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Items
{
    public class MourningShield : ModItem
    {
	public override void Effects(Player p) //This is called a hook. This is where the effects are called. In this instance, it is called when the player has it equipped. It must have the correct parameters (the "Player p" thing) or else the builder will give you errors.
        {
            p.knockbackResist = 0;
        }
	public override void DamagePlayer(NPC n, Player p, int hitDir, ref int damage, ref bool crit, ref float critMult)
	{
	    n.AddBuff(24,300,true);
            Projectile.NewProjectile(p.position.X, p.position.Y, -4, -4, 323, 60, 0f, p.whoAmI, -4, -4);
            Projectile.NewProjectile(p.position.X, p.position.Y, -4, 4, 323, 60, 0f, p.whoAmI, -4, 4);
            Projectile.NewProjectile(p.position.X, p.position.Y, 4, -4, 323, 60, 0f, p.whoAmI, 4, -4);
            Projectile.NewProjectile(p.position.X, p.position.Y, 4, 4, 323, 60, 0f, p.whoAmI, 4, 4);
	}
    }
}