using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Items
{
    public class Molten2Breastplate : ModItem
    {
        public override void Effects(Player p)
        {
            p.meleeDamage += 0.21f;
        }

	public override void ArmorSetBonus(Player p)
	{
            p.setBonus = "+25% Melee Speed and Magma Stone Effect";
	    p.drawAura = true;
	    p.meleeSpeed += 0.25f;
	    p.magmaStone = true;
	    int dustID = Dust.NewDust(p.position, p.width, p.height, 6, p.velocity.X * 0.1f, p.velocity.Y * 0.1f, 20, Color.White, 0.6f);
	}

	public override void VanitySetBonus(Player p)
	{
	    int dustID = Dust.NewDust(p.position, p.width, p.height, 6, p.velocity.X * 0.1f, p.velocity.Y * 0.1f, 20, Color.White, 0.6f);
	}
    }
}