using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Items
{
    public class PetalBreastplate : ModItem
    {
	public override void ArmorSetBonus(Player p)
	{
            p.setBonus = "Set off Stationary Petals when under 25% HP";

            if(p.statLife <= (int)p.statLifeMax/4)
            {
                if (Main.rand.Next(75) == 0)
                {
                    Projectile.NewProjectile(p.position.X, p.position.Y, 0f, 0f, 248, 40, 6, p.whoAmI, 0f, 0f);
                }
            }
    	}

        public override void Effects(Player p)
        {
            p.magicDamage += 0.11f;
	    p.manaCost -= 0.08f;
	    p.statManaMax2 += 40;
        }
    }
}