using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;  //all these using lines tell the mod what to use as resources for the code we will be doing.

namespace Terra.Items
{
    public class Spectrehelmet : ModItem
    {
        public override void Effects(Player p) //This is called a hook. This is where the effects are called. In this instance, it is called when the player has it equipped. It must have the correct parameters (the "Player p" thing) or else the builder will give you errors.
        {
            p.statManaMax2 += 100;
            p.manaCost -= 0.15f;
            p.AddBuff("Terra:SpectreBuff",1,true);
        }
	public override void ArmorSetBonus(Player p)
	{
            p.setBonus = "Magic Damage will Summon Mana Wisps";
    	}
	public override void DamageNPC(Player p, NPC npc, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
	{
	     Projectile.NewProjectile(npc.position.X, npc.position.Y, 5, 5, "Terra:SpectreWisp", 1, 0);
	}
    }
}