using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Items
{
    public class SunfirePlating : ModItem
    {
        public override void Effects(Player p)
        {
            p.rangedDamage += 0.08f;
	    p.magicDamage += 0.08f;
        }

	public override void ArmorSetBonus(Player p)
	{
            p.setBonus = "Enemies who are too close take Fire Damage";
	    p.drawAura = true;

            float closestDistance = 150f;
	    for(int k = 0; k < 200; k++)
	    {
		NPC npc = Main.npc[k];
		if(npc.active && !npc.friendly)
		{
        	    if(Vector2.Distance(npc.Center, p.Center) < closestDistance)
        	    {
            		npc.AddBuff(24,30,true);
        	    }
		}
	    }
	}
    }
}