using Terraria;
using System;
using System.Diagnostics;
using Microsoft.Xna.Framework;

using TAPI; //The resources the code will be using for all the variables

namespace Terra.Items
{
public class Snowcrasher : ModItem
    {
	public override void UseItemEffects(Player player, Rectangle rectangle)
	{
	    int dustID = Dust.NewDust(new Vector2((float)rectangle.X, (float)rectangle.Y), rectangle.Width, rectangle.Height, 67, (player.velocity.X * 0.2f) + (player.direction * 3), player.velocity.Y * 0.2f, 100, Color.Orange, 0.7f + (Main.rand.Next(6) * 0.1f));
	    Main.dust[dustID].noGravity = true;
	}
        public override void DamageNPC(Player owner, NPC npc, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult) //The code will be called when the item hits an NPC
        {
            npc.AddBuff (44, 420, true); //24 is the "On Fire!" buff ID, 300 is the duration (5 seconds), and you know what "true" means! (Not all buffs and debuffs can be applied to NPCs!)
        }
    }
}