using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.NPCs
{
    public class Underlord : ModNPC
    {
	public override bool CanSpawn( int x, int y, int type, Player spawnedOn)
	{	
	    if (y >= Main.hellLayer &&
            ((!Main.dayTime &&  !Main.bloodMoon && Main.hardMode && Main.rand.Next(3) == 0) ||
            (!Main.dayTime &&  Main.bloodMoon && Main.hardMode && Main.rand.Next(3) == 0)) )
            {
                return true;
            }
        return false;
	}
	public override void AI()
        {
	    int choice = Main.rand.Next(240);
		if(choice == 0)
		{
    		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, 4f, 4f, 350, 50, 0f);
		}
		else if(choice == 30)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, -4f, -4f, 350, 50, 0f);
		}
		else if(choice == 60)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, 4f, 0f, 350, 50, 0f);
		}
		else if(choice == 90)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, -4f, 0f, 350, 50, 0f);
		}
		else if(choice == 120)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, 0f, 4f, 350, 50, 0f);
		}
		else if(choice == 150)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, 0f, -4f, 350, 50, 0f);
		}
		else if(choice == 180)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, 4f, -4f, 350, 50, 0f);
		}
		else if(choice == 210)
		{
		    Projectile.NewProjectile(npc.Centre.X, npc.Centre.Y, -4f, 4f, 350, 50, 0f);
		}
	}
    }
}