using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Projectiles
{
    public class HealBolt : ModProjectile
    {
        public override bool OnTileCollide(ref Vector2 velocityChange) 
        {
            if(projectile.ai[0] < 1f)
            {
                if (projectile.velocity.X != velocityChange.X) 
                {
                    projectile.velocity.X = -velocityChange.X; 
                }
                if     (projectile.velocity.Y != velocityChange.Y) 
                { 
                    projectile.velocity.Y = -velocityChange.Y; 
                }
                projectile.ai[0] += 1f;
                return false;
            }
            else
            {
                return true;
            }
        }
	public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
	{
          p.statLife += p.statLifeMax/12;
	}
    }
}