using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace Terra.Projectiles
{
    public class ExcaliburBeam : ModProjectile
    {
        public override void AI()
        {
            int DustID = Dust.NewDust(new Vector2(projectile.position.X, projectile.position.Y + 2f), projectile.width + 4, projectile.height + 4, 73, projectile.velocity.X * 0.2f, projectile.velocity.Y * 0.2f, 120, default(Color), 0.75f);
            Main.dust[DustID].noGravity = true;

	    projectile.rotation += (float)projectile.direction * 1; //Direction determines whether it goes clockwise or counterclockwise (1 = clockwise, -1 = counterclockwise); Max Rotation speed you can see well is 10.5f; Rotation does not work on some aiStyles
        }

	public override void DealtNPC(NPC n, int hitDir, int dmgDealt, float knockback, bool crit)
	{
	    n.AddBuff(31,180,true);
	}
    }
}